var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 11 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 11 ? d(r) : c > 11 ? d(target, key, r) : d(target, key)) || r;
    return c > 11 && r && Object.defineProperty(target, key, r), r;
};
define(["require", "exports", "language/Translation", "mod/Mod", "mod/ModRegistry", "newui/component/Button", "newui/component/CheckButton"], function (require, exports, Translation_1, Mod_1, ModRegistry_1, Button_1, CheckButton_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var DragonQuestMusicTranslation;
    (function (DragonQuestMusicTranslation) {
        DragonQuestMusicTranslation[DragonQuestMusicTranslation["OptionsOnlyDragonQuestMusic"] = 0] = "OptionsOnlyDragonQuestMusic";
        DragonQuestMusicTranslation[DragonQuestMusicTranslation["OptionsPlayTrackDQM01"] = 1] = "OptionsPlayTrackDQM01";
        DragonQuestMusicTranslation[DragonQuestMusicTranslation["OptionsPlayTrackDQM02"] = 2] = "OptionsPlayTrackDQM02";
		DragonQuestMusicTranslation[DragonQuestMusicTranslation["OptionsPlayTrackDQM03"] = 3] = "OptionsPlayTrackDQM03";
		DragonQuestMusicTranslation[DragonQuestMusicTranslation["OptionsPlayTrackDQM04"] = 4] = "OptionsPlayTrackDQM04";
        DragonQuestMusicTranslation[DragonQuestMusicTranslation["OptionsPlayTrackDQM05"] = 5] = "OptionsPlayTrackDQM05";
		DragonQuestMusicTranslation[DragonQuestMusicTranslation["OptionsPlayTrackDQM06"] = 6] = "OptionsPlayTrackDQM06";
		DragonQuestMusicTranslation[DragonQuestMusicTranslation["OptionsPlayTrackDQM07"] = 7] = "OptionsPlayTrackDQM07";
        DragonQuestMusicTranslation[DragonQuestMusicTranslation["OptionsPlayTrackDQM08"] = 8] = "OptionsPlayTrackDQM08";
		DragonQuestMusicTranslation[DragonQuestMusicTranslation["OptionsPlayTrackDQM09"] = 9] = "OptionsPlayTrackDQM09";
		DragonQuestMusicTranslation[DragonQuestMusicTranslation["OptionsPlayTrackDQM10"] = 10] = "OptionsPlayTrackDQM10";
    })(DragonQuestMusicTranslation || (DragonQuestMusicTranslation = {}));
    class DragonQuestMusic extends Mod_1.default {
        get tracks() {
            return {
                DQM01: this.musicTrackDQM01,
                DQM02: this.musicTrackDQM02,
				DQM03: this.musicTrackDQM03,
				DQM04: this.musicTrackDQM04,
                DQM05: this.musicTrackDQM05,
				DQM06: this.musicTrackDQM06,
				DQM07: this.musicTrackDQM07,
                DQM08: this.musicTrackDQM08,
				DQM09: this.musicTrackDQM09,
				DQM10: this.musicTrackDQM10
            };
        }
        onInitialize() {
            this.refreshMusicHandler(true);
        }
        onUninitialized() {
            this.resetMusicHandler();
        }
        resetMusicHandler() {
            audio.resetMusicHandler();
            audio.playMusic();
        }
        refreshMusicHandler(isInitialization = false) {
            if (this.globalData.onlyDragonQuestMusic) {
                audio.getMusicHandler()
                    .filter(name => name.slice("ModDragonQuestMusic".length) in this.tracks)
                    .moveToRandom();
            }
            else if (isInitialization) {
                audio.getMusicHandler().refresh();
            }
            else {
                this.resetMusicHandler();
            }
        }
        constructOptionsSection(section) {
            new CheckButton_1.CheckButton()
                .setText(() => new Translation_1.default(this.dictionary, DragonQuestMusicTranslation.OptionsOnlyDragonQuestMusic))
                .setRefreshMethod(() => !!this.globalData.onlyDragonQuestMusic)
                .event.subscribe("toggle", (_, checked) => {
                this.globalData.onlyDragonQuestMusic = checked;
                this.refreshMusicHandler();
            })
                .appendTo(section);
            for (const track of Stream.keys(this.tracks)) {
                new Button_1.default()
                    .setText(() => new Translation_1.default(this.dictionary, `OptionsPlayTrack${track}`))
                    .event.subscribe("activate", () => {
                    audio.getMusicHandler().moveToEnumEntry(this.tracks[track]);
                })
                    .appendTo(section);
            }
        }
    }
    __decorate([
        ModRegistry_1.default.dictionary("DragonQuestMusic", DragonQuestMusicTranslation)
    ], DragonQuestMusic.prototype, "dictionary", void 0);
    __decorate([
        ModRegistry_1.default.musicTrack("DQM01")
    ], DragonQuestMusic.prototype, "musicTrackDQM01", void 0);
    __decorate([
        ModRegistry_1.default.musicTrack("DQM02")
    ], DragonQuestMusic.prototype, "musicTrackDQM02", void 0);
	__decorate([
        ModRegistry_1.default.musicTrack("DQM03")
    ], DragonQuestMusic.prototype, "musicTrackDQM03", void 0);
	__decorate([
        ModRegistry_1.default.musicTrack("DQM04")
    ], DragonQuestMusic.prototype, "musicTrackDQM04", void 0);
    __decorate([
        ModRegistry_1.default.musicTrack("DQM05")
    ], DragonQuestMusic.prototype, "musicTrackDQM05", void 0);
	__decorate([
        ModRegistry_1.default.musicTrack("DQM06")
    ], DragonQuestMusic.prototype, "musicTrackDQM06", void 0);
	__decorate([
        ModRegistry_1.default.musicTrack("DQM07")
    ], DragonQuestMusic.prototype, "musicTrackDQM07", void 0);
    __decorate([
        ModRegistry_1.default.musicTrack("DQM08")
    ], DragonQuestMusic.prototype, "musicTrackDQM08", void 0);
	__decorate([
        ModRegistry_1.default.musicTrack("DQM09")
    ], DragonQuestMusic.prototype, "musicTrackDQM09", void 0);
	__decorate([
        ModRegistry_1.default.musicTrack("DQM10")
    ], DragonQuestMusic.prototype, "musicTrackDQM10", void 0);
    __decorate([
        Mod_1.default.globalData("DragonQuest Music")
    ], DragonQuestMusic.prototype, "globalData", void 0);
    __decorate([
        ModRegistry_1.default.optionsSection
    ], DragonQuestMusic.prototype, "constructOptionsSection", null);
    exports.default = DragonQuestMusic;
});
